/****************************************************************************
 *
 *   applet.h
 *
 *   Copyright (c) 1991 Microsoft Corporation.  All Rights Reserved.
 *
 *   Example header to create a DLL to control applet(s) to be
 *   displayed by the Multimedia Control Panel.
 *
 ***************************************************************************/

#define HV_INVALID      100000.0        // invalid hsweep value

#define BIGSIZE 3000            // offset for BigCursor resources
//
// Values returned by SwitchMonitor()
//
#define DISP_CRT        0       // CRT display
#define DISP_PANEL      1       // Panel display
#define DISP_SIMUL      2       // CRT + Palne (Simultaneous)


#define DDPanel         1

/*
* Hardware configuration supported
*/
#define F65510          0       // Vampire family
#define F65530          1       // Vampire family
#define F65535          2       // Vampire family
#define F65540          3       // Vampire family
#define F65545          4       // Vampire family
#define F65546          5       // Vampire family
#define F65548          6       // Vampire family
#define F64200          7       // Wingine
#define F64300          8       // Orca
#define F64310          9       // Orca
#define F64301          10      // Orca2
#define CHIPS_OLD       11      // Chips old VGAs (451/452/453/455/456/457)
#define UNKNOWN_HW      -1

//
// panel_type flag defintion
//
#define TFT_PANEL       0       // Bit D0: 1 for STN Panel
#define STN_PANEL       1
#define MONO_PANEL      0       // Bit D1: 1 for Color Panel
#define COLOR_PANEL     2

#define SYS   0x10  // Indicates that this goes in system directory.
 
 
#define NUM_APPLETS             1
#define         EXAMPLE_APPLET_1        1

/* icons */
#define LOGOICON        1
#define CRTICON         2
#define LCDICON         3
#define BOTHICON        4
#define BIGCURICON      5
//#define       XRAMICON        6



/* dialog boxes */
#define CRTSetupBox     1000    // CRT Setup dialog box
#define FPSetupBox      1001    // Flat panel setup diaglog box
#define ExitDialog      1002
#define WarnDialog      1003
#define AboutBox        1004
#define VersionDialog   1005    // Version dialogbox
#define PanelQualityDlg 1006    // Panel Features
#define PromptDlg       1007    // Prompt for missing files
#define FPRefBox        1008    // Flat panel Mult Refresh setup diaglog box

#define CRT_SIZE_X      190     // size of CRT Dialogbox, used in Window Creation
#define CRT_SIZE_Y      180
#define FP_SIZE_X       238     // size of FP Dialogbox
#define FP_SIZE_Y       190

#define IDS_NAME        100
#define IDS_INFO        200

/***************** menu items ********************/
// exit dialog box
#define ExitReboot      101
#define ExitCancel      102

#define IDM_ABOUT       100             // system menu command
#define IDM_TITLE_BAR   18

// setup dialog box that common for CRT and Flat Panel
#define IDD_DUMMY       -1              // don't care (for "static" controls)

#define IDD_SCREENSIZE  200             // don't care (for "static" controls)
#define IDD_640X480     201             // 640x480
#define IDD_800X600     202             // 800x600
#define IDD_1024X768    203             // 1024x768
#define IDD_1280X1024   204             // 1280x1024
#define N_SCREENSIZE    (IDD_1280X1024-IDD_640X480+1)   // 480,600,768,1024 (column)

#define IDD_COLOR       210             // don't care (for "static" controls)
#define IDD_4BPP        211             // 16 colors
#define IDD_8BPP        212             // 256 colors
#define IDD_15BPP       213             // 16K colors
#define IDD_16BPP       214             // 32K colors
#define IDD_24BPP       215             // 16M colors
#define IDD_32BPP       216             // 16M colors (32 bit per pixel)
#define N_COLORFORMAT   (IDD_32BPP-IDD_4BPP+1)  // 4,8,15,16,24,32 (row)

#define IDD_REFRESH     220
#define IDD_INTERLACED  221
#define IDD_56HZ        222
#define IDD_60HZ        223
#define IDD_70HZ        224
#define IDD_72HZ        225
#define IDD_75HZ        226
#define N_REFRESH       (IDD_75HZ - IDD_INTERLACED +1)

#define IDD_FONT        230
#define IDD_SMALLFONT   231
#define IDD_LARGEFONT   232
#define M_FONTS   (IDD_LARGEFONT-IDD_SMALLFONT+1)   // (FONTS for English)
#define IDD_CURSORANIM  233             // cursor animation for (Wait cursor for Orca Only)
#define IDD_VERSION     234             // Version info button

#define IDD_CURRENTDRV  240             // static text for current drv
#define IDD_MONITORSPEC 241             // display monitor h/v parameter
#define IDD_MONITORTYPE 242             // list of monitor type (combo box)
#define IDD_OK          243

//
// Flat Panel Only 
//
#define IDD_BIGCURSOR   250             // Bigcursor 
#define IDD_PANELQ      251             // PanelQuality dialog
#define IDD_CRT         260             // CRT mode (must be in order)
#define IDD_PANEL       261             // LCD mode
#define IDD_SIMUL       262             // Simultaneous mode

//#define       IDD_PWRSAVE     270
#define IDD_BKLITEOFF   270             // Backlite off
#define IDD_PANELOFF    271             // Panel off
#define IDD_ACTVTIME    272             // Activity time
#define IDD_TACTVTIME   273             // Activity time

#define IDD_FONTD       280             // don't care (for "static" controls)
#define IDD_FONT12      281             // FONT 12
#define IDD_FONT16      282             // FONT 16
#define IDD_FONT20      283             // FONT 20
#define IDD_FONT24      284             // FONT 24
#define N_FONTS   (IDD_FONT24-IDD_FONT12+1)   // 12, 16, 20, 24 (FONTS)

//
// Panel quality dialog box
//
#define IDD_GSCTRL      330             // Group box
#define IDD_NTSC        331             // Mono Panel Only
#define IDD_EQWT        332             // Mono Panel Only
#define IDD_GREENGUN    333             // Mono Panel Only

#define IDD_FRC0        340             // No FRC
#define IDD_FRC2        341             // 2 frame FRC
#define IDD_FRC4        342             // 4 frame FRC
#define IDD_FRC8        343             // 8 frame FRC
#define IDD_FRC16       344             // 16 frame FRC
#define IDD_FRC32       345             // 32 frame FRC

#define IDD_DITHER      348             // Dither enable

#define IDD_GRAYBAR0    350             // 16 static gray bars
#define IDD_GRAYBAR1    351
#define IDD_GRAYBAR2    352
#define IDD_GRAYBAR3    353
#define IDD_GRAYBAR4    354
#define IDD_GRAYBAR5    355
#define IDD_GRAYBAR6    356
#define IDD_GRAYBAR7    357
#define IDD_GRAYBAR8    358
#define IDD_GRAYBAR9    359
#define IDD_GRAYBARA    360
#define IDD_GRAYBARB    361
#define IDD_GRAYBARC    362
#define IDD_GRAYBARD    363
#define IDD_GRAYBARE    364
#define IDD_GRAYBARF    365

#define IDD_MV          366             // M Scroll Bar
#define IDD_NV          367             // N Scroll Bar
#define IDD_M           368             // M Scroll Bar
#define IDD_N           369             // N Scroll Bar
#define IDD_POLYNOMIAL  370

#define IDD_RESET       380             // Reset each to default 
#define IDD_RESETALL    381             // Reset all to default
#define IDD_CANCEL      382
#define IDD_GRAYON      383
#define N_GRAYBARS      (IDD_GRAYBARF-IDD_GRAYBAR0+1)

#define IDD_DUTYCYCLE   390
#define IDD_DUTY        391
#define IDD_DUTYV       392

//
// Version dialog box
//
#define IDD_VNAME       400
#define IDD_VDATETIME   401
#define IDD_VSIZE       402
#define IDD_VVERSION    403


#define MAX_PATH_LEN    128

// SH 12/12/94
// IDS for string table resource
#define IDS_SPACE       501
#define IDS_COLORS      502
#define IDS_DOT         503
#define IDS_FONT        504
#define IDS_SMALL       505
#define IDS_LARGE       506
#define IDS_VGA         507
#define IDS_HZ          508
#define IDS_INTERLACED  509

#define IDS_640X480     550
#define IDS_800X600     551
#define IDS_1024X768    552
#define IDS_1280X1024   553

#define IDS_4B          560
#define IDS_8B          561
#define IDS_15B         562
#define IDS_16B         563
#define IDS_24B         564

#define IDS_16          570
#define IDS_256         571
#define IDS_32K         572
#define IDS_64K         573
#define IDS_16M         574

#define IDS_I           580
#define IDS_56          581
#define IDS_60          582
#define IDS_70          583
#define IDS_72          584
#define IDS_75          585

#define IDS_F12         591             // FONT 12
#define IDS_F16         592             // FONT 16
#define IDS_F20         593             // FONT 20
#define IDS_F24         594             // FONT 24

// Prompt Dialog box
#define IDD_PROMPT      600
#define IDD_PDISK       601
#define IDD_PMSG1       602
#define IDD_PMSG2       603
#define IDD_PMSG3       604
#define IDD_PMSG4       604
#define IDD_PPATH       605
#define IDD_PFILE       606

#define IDS_PD1         620
#define IDS_PD2         621
#define IDS_PD3         622
#define IDS_PD4         623
#define IDS_PD5         624
#define IDS_PInsert     625
#define IDS_PMissingFile 626

#define N_DISKS         5

// Error Messages
#define IDS_ErrorMsg    640
#define IDS_Error       641



//
// Defintion for Refresh (same defintion is also used by BIOS)
//
#define RF_INTERLACED   1       // bit 0 is set if Interlaced is s
#define RF_56HZ         2       // bit 1 for 56Hz
#define RF_60HZ         4       // bit 2 for 60Hz
#define RF_70HZ         8       // bit 3 for 70Hz
#define RF_72HZ         16      // bit 4 for 72Hz
#define RF_75HZ         32      // bit 5 for 75Hz
//
// Defintion for Disabled
//
#define DF_MEMORY       1       // disabled because of memory constraints
#define DF_BIOS         2       // disabled because of BIOS
#define DF_MONITOR      4       // disabled because of monitor constraints

#define CUR_SEL_SECTION "CurrentSelection"      // CHIPSCPL.INI file's CurSel section
#define CUR_SEL         "Monitor"               // CHIPSCPL.INI file's CurSel


extern  HANDLE          hwnd;   
extern  HANDLE          myInstance;
extern void FAR PASCAL LaunchApplet(HWND hCPl, int index, LONG lParam);
extern BOOL FAR PASCAL Applet1_DlgProc(HWND hDlg, unsigned message, WORD wParam, LONG lParam );
BOOL FAR PASCAL _loadds WarnDlgProc(HWND hwnd, unsigned wMsg, WORD wParam, LONG lParam);
BOOL FAR PASCAL _loadds ExitDlgProc(HWND hwnd, unsigned wMsg, WORD wParam, LONG lParam);
//int FAR PASCAL SwitchMonitor(int type); // imported from driver
BOOL GetDrvDesAspect(int iColor, int iSize, int iFontSize);
char *next_field(char *p);
BOOL IsFileExist(HWND hwnd, const char *file, unsigned idisk);
BOOL FAR PASCAL _loadds AboutWndProc(HWND hDlg,unsigned message, WORD wParam, LONG lParam);
BOOL FAR PASCAL InitApplet(void);

//
// Function prototypes for PANEL.C
//
BOOL FAR PASCAL _loadds PanelQualityDlgProc(HWND hwnd,unsigned wMsg,WORD wParam,LONG lParam);
void ResetPowerSave(HWND hwnd, int f_crt);
void CreateGrayBarBrush(HWND hwnd);
void SetGrayBars(HWND hwnd);
void ResetGrayBars(HWND hwnd);
void ChangeCursor(int iResId);

//
// Functions proto types from DRIVER.CPP
//
#ifdef __cplusplus
extern "C" {
#endif
void CreateFontSizeTable (void) ;
void CreateDriverEntryTable(WORD chip_type,WORD nVMemSizeKb);
void DeleteDriverEntryTable(void);
char *GetDriverInfId(int iColor, int iSize);

//SH 12/15/94
void EnableFontSizeButtons (HWND hwnd, int iSize);

void EnableColorFormatButtons(HWND hwnd, int iSize);

//SH 12/15/94
// void EnableScreenSizeButtons(HWND hwnd, int iColor);
void EnableScreenSizeButtons (HWND hwnd, int iColor, int iSize);

//SH 12/15/94
void _loadds LoadDialogStrings (void);

int  EnableRefreshButtons(HWND hwnd, int iColor, int iSize, int f_crt);
int SetCurModeFontSize(HWND hwnd, int iColor, int iSize, int iFontSize);
int  CheckFontSizeButtons(HWND hwnd, int iColor, int iSize);
void SetRefreshRate(HWND hwnd, int iColor, int iSize, int iRefresh);
void ReadRefreshFromINI(void);
void DisableDriverSetup(HWND hwnd, int f_crt);
void ApplyMonitorConstraints(void);
void DisplayModeHSweepVRef(HWND hwnd, int iRefresh, int iScreen,int f_crt);
BOOL ValidateMonitor(HWND hwnd, int iRefresh, int iScreen);
#ifdef __cplusplus
    }   // extern "C"
#endif

//
// Function Prototypes in Monitor.C
//
int FillMonitorBox(HWND hwnd, char *ini_file);
BOOL SelectMonitor(HWND hwnd,int cur_ind,char *cur_str,char *ini_file,int iRefresh,int iSize);
void UpdateCurrentSelection(char *gBuf, char *ini_file);

#ifdef  __cplusplus
extern "C" {
#endif
BOOL VerifyMonitor(float hsweep, float vrfresh);
void GetMaxCurMonitorParam(float far *hsweep,float far *vrefresh);
#ifdef __cplusplus
    }   // extern "C"
#endif


//
// Function proto in Version.c
//
BOOL GetDrvVersionInfo(HWND hwnd);
BOOL FAR PASCAL _loadds VersionDlgProc(HWND hwnd,unsigned wMsg,WORD wParam,LONG lParam);


/* Function Prototypes in ChipsHW.C */
int  GetHWConfig(void);
int  GetDisplayType(void);
void SetDisplayType(int display_type);
int  GetGrayScaleReduction(void);
void SetGrayScaleReduction(int gsr_type);
int  GetFRC(void);
void SetFRC(int frc_level);
int  GetPanelType(void);
int  GetActivityTime();
int  GetActivityTime(void);
void SetActivityTime(int time_in_hmin);
int  GetPanelOff(void);
void SetPanelOff(int panel_off);
int  GetDither(void);
void SetDither(int dither_type);
int  GetM(void);
void SetM(int m_value);
int  GetN(void);
void SetN(int n_value);
void SaveHwPalette(int start_ind, int n_entries, PALETTEENTRY *npPal);
void RestoreHwPalette(int start_ind, int n_entries, PALETTEENTRY *npPal);
void SetHwPalette(int start_ind, int n_entries, PALETTEENTRY *npPal);
void ReadHwAttribute(void);
void SaveHwPalette_4(PALETTEENTRY *npPal);
void RestoreHwPalette_4(PALETTEENTRY *npPal);
void SetHwPalette_4(PALETTEENTRY *npPal);
int  GetDDType(void);
void SetXRAM(int x_value);
int  GetXRAM(void);


//SH 01/17/95 Prompt for missing files
unsigned GetFile (HWND hwnd, const char *file, unsigned idisk);
unsigned FAR PASCAL _loadds PromptWndProc (HWND hDlg, unsigned message, WORD wParam, LONG lParam);

typedef struct  tagDUTYCYCLEENTRY
	{
	BYTE vTotal;                    // xr64 vertical total
	BYTE vSyncS;                    // xr66 vertical sync start
	BYTE vSyncE;                    // xr67 vertical sync end
	} DUTYCYCLEENTRY;

void SetDutyCycle(int index,DUTYCYCLEENTRY *npCycle);
int  GetDutyCycle(DUTYCYCLEENTRY *npCycle);


// cursor structure (pulled out from ...)
typedef struct  CURSORHEADER
	{
	WORD wHotSpotX;                 // X hotspot coordinate
	WORD wHotSpotY;                 // Y hotspot coordinate
	WORD wExtentX;                          // X dimension of cursor
	WORD wExtentY;                          // Y dimension of cursor
	WORD Reserved;
	BYTE ucNumberOfPlanes;  // color plane
	BYTE ucBitPerPixel;             // bit per pixel
	} CURSORHEADER;
typedef CURSORHEADER FAR * LPCURSORHEADER;

//------------------------------------------------------------------------
// Display driver Escape support. Signature bytes must have "CHIP"
//------------------------------------------------------------------------
#define CHIPS_ESCAPE            13      // Chips And Tech Escape support
#define CTE_BIGCURSOR           1       // sub-function for big cursor support
			// lpInData+2 is 0/1 to turn off/on big cursor
#define CTE_CURANIMATION        2       // sub-function for cursor animation (orca)
			// lpInData+2 is 0/1 to turn off/on cursor animation (Orca)
#define CTE_SETBIOSMODE         3       // sub-function for change display mode (for on the fly mode change)
			// lpInData+2 is width in pixel for desired resolution
			// lpInData+4 is height in scanlines for desired resolution
			// lpInData+6 is 96/120 for fornt size (don't know if will work)
//------------------------------------------------------------------------
// lpInData (input buffer) structure used for Chips & Tech EscapeNo support
// in Control. Both QUERY_ESCAPE & CHIPS_ESCAPE use the same format.
//------------------------------------------------------------------------
typedef struct {
WORD    EscapeNo;               // Escape Sequence number (CHIPS_ESCAPE)
WORD    SubFunction;            // sub-function (CTE_*)
BYTE    Signature[4];           // Chips Signature ([0]='C'...[3]='P' "CHIP"
WORD    wParam1;                // Word parameter 1
WORD    wParam2;                // Word parameter 2
WORD    wParam3;                // Word parameter 3
WORD    wParam4;                // Word parameter 4 (and many more as needed)
} CONTROLINBUFFER;
